package com.codigoparallevar.minicards.parts;

import android.util.Log;

import com.codigoparallevar.minicards.ScrolledCanvas;
import com.codigoparallevar.minicards.types.Moveable;
import com.codigoparallevar.minicards.types.Part;
import com.codigoparallevar.minicards.types.PartGrid;
import com.codigoparallevar.minicards.types.connectors.input.InputConnector;
import com.codigoparallevar.minicards.types.connectors.output.OutputConnector;
import com.codigoparallevar.minicards.types.functional.Tuple2;
import com.codigoparallevar.minicards.types.wireData.WireDataType;
import com.programaker.api.data.ProgramakerCustomBlock;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.List;
import java.util.UUID;

public class ProgramakerCustomBlockPart implements Part {


    private final PartGrid _partGrid;
    private final String _id;
    private int _xCenter;
    private int _yCenter;
    private final ProgramakerCustomBlock _block;

    public ProgramakerCustomBlockPart(String id, PartGrid grid, Tuple2<Integer, Integer> center, ProgramakerCustomBlock block) {
        this._id = id;
        this._partGrid = grid;
        this._xCenter = center.item1;
        this._yCenter = center.item2;
        this._block = block;
    }

    public ProgramakerCustomBlockPart(PartGrid grid, Tuple2<Integer, Integer> center, ProgramakerCustomBlock block) {
        this(UUID.randomUUID().toString(), grid, center, block);
    }

    @Override
    public int get_left() {
        return 0; // TODO: Implement
    }

    @Override
    public int get_right() {
        return 0; // TODO: Implement
    }

    @Override
    public int get_top() {
        return 0; // TODO: Implement
    }

    @Override
    public int get_bottom() {
        return 0; // TODO: Implement
    }

    @Override
    public void touched() {
        Log.i("CustomBlockPart", "Part touched (block_fun=" + this._block.getFunction_name() + ")");
    }

    @Override
    public List<InputConnector> getInputConnectors() {
        return null;
    }

    @Override
    public List<OutputConnector> getOutputConnectors() {
        return null;
    }

    @Override
    public JSONObject serialize() throws JSONException {
        return null;
    }

    @Override
    public void send(InputConnector inputConnector, WireDataType signal) {

    }

    @Override
    public String get_id() {
        return _id;
    }

    @Override
    public InputConnector getConnectorWithId(String inputConnectorId) {
        return null;
    }

    @Override
    public String getConnectorId(InputConnector inputConnector) {
        return null;
    }

    @Override
    public void resume() {
        // Intentionally left empty
    }

    @Override
    public void pause() {
        // Intentionally left empty
    }

    @Override
    public void draw(ScrolledCanvas canvas, boolean devMode) {
        // TODO: Implement
    }

    @Override
    public void moveEnd(int x, int y) {
        // TODO: Implement moving connectors
    }

    @Override
    public void drop(int x, int y) {
        moveEnd(x, y);
    }

    @Override
    public boolean containsPoint(int x, int y) {
        return ((x >= this.get_left()) && (x <= this.get_right())
                && (y >= this.get_top()) && (y <= this.get_top()));
    }

    @Override
    public Moveable getMoveable() {
        return this;
    }

    @Override
    public void unlink() {
        // TODO: Implement
    }
}
