package com.codigoparallevar.minicards.types;

import com.codigoparallevar.minicards.types.connectors.input.InputConnector;
import com.codigoparallevar.minicards.types.connectors.output.OutputConnector;
import com.codigoparallevar.minicards.types.wireData.WireDataType;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.List;

public interface Part extends Selectable, Moveable, Drawable {
    int get_left();
    int get_right();
    int get_top();
    int get_bottom();

    void touched();

    List<InputConnector> getInputConnectors();
    List<OutputConnector> getOutputConnectors();

    JSONObject serialize() throws JSONException;

    void send(InputConnector inputConnector, WireDataType signal);

    String get_id();

    InputConnector getConnectorWithId(String inputConnectorId);

    String getConnectorId(InputConnector inputConnector);

    void resume();
    void pause();
}
