package com.codigoparallevar.minicards.types.connectors.output;

import com.codigoparallevar.minicards.ScrolledCanvas;
import com.codigoparallevar.minicards.types.Dropper;
import com.codigoparallevar.minicards.types.Selectable;
import com.codigoparallevar.minicards.types.functional.Tuple2;
import com.codigoparallevar.minicards.types.connectors.Wiring.Wire;
import com.codigoparallevar.minicards.types.connectors.input.InputConnector;
import com.codigoparallevar.minicards.types.wireData.WireDataType;

import java.util.List;

public interface OutputConnector<T extends WireDataType,
        T1 extends InputConnector<T, T1>,
        T2 extends Wire<T, T1>>
        extends Selectable, Dropper<T2> {

    void drawWires(ScrolledCanvas canvas, boolean devMode);
    void updatePosition(int x, int y);

    List<Tuple2<String, String>> getConnectionEndpoints();

    void connectTo(T1 inputConnector);

    void send(T data);
}
